djangoProject1/blog/urls.py
from django.urls import path

from blog.views import home_view, post_detail_view, post_create_view, PostCreateView, PostDetailView, PostListView, \
    PostDeleteView, PostUpdateView, CommentCreateView

app_name = 'blog'

urlpatterns = [
    path('', PostListView.as_view(), name='home'),
    # path('', home_view, name='home'),
    # path('create/post/', post_create_view, name='post-create'),
    path('create/post/', PostCreateView.as_view(), name='post-create'),
    path('posts/<int:pk>/', PostDetailView.as_view(), name='post-detail'),
    path('posts/<int:pk>/delete/', PostDeleteView.as_view(), name='post-delete'),
    path('posts/<int:pk>/update/', PostUpdateView.as_view(), name='post-update'),
    path('comment/add/', CommentCreateView.as_view(), name='comment-create'),
]

djangoProject1/djangoProject1/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from django.conf import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('blog.urls')),
    path('', include('users.urls')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

djangoProject1/users/urls.py
from django.urls import path
from users.views import SignInView, SignOutView, SignUpView, ProfileView

app_name = 'users'

urlpatterns = [
    path('sign-in/', SignInView.as_view(), name='sign-in'),
    path('sign-out/', SignOutView.as_view(), name='sign-out'),
    path('sign-up/', SignUpView.as_view(), name='sign-up'),
    path('profile/<int:pk>/', ProfileView.as_view(), name='profile'),
]

djangoProject1/blog/models.py
from django.db import models
from django.urls import reverse
from django.utils import timezone

"""
QuerySet API
to use QuerySet API you have to access static attribute "objects"
ModelName.objects
Post.objects.all() -> all post that is in the database
ModelName.objects.first() -> earliest write in database for this model table
ModelName.objects.last() -> most recent write in database for this model table
ModelName.objects.filter() -> filter  model's table for specific information
* from django.utils import timezone
* Post.objects.filter(id=1)
* Post.objects.filter(create_time__date=timezone.now().date())
* Post.objects.filter(title__icontains="T")
ModelName.objects.get() -> Single object; there should be only one with field you are searching

object / instance methods
* save() -> sync application to database
* refresh_from_db() -> sync changes to application from DB (database)
* delete() -> deletes object from database
"""


# Create your models here.
# ORM - Object Relational Mapping / Mapper

class Tag(models.Model):
    name = models.CharField(max_length=60, unique=True)

    def save(self, *args, **kwargs):
        self.name = self.name.lower()
        super().save(*args, **kwargs)

    def __str__(self) -> str:
        return f'{self.name}'


class Post(models.Model):
    tags = models.ManyToManyField(Tag, blank=True)
    author = models.ForeignKey('users.User', on_delete=models.CASCADE)

    title = models.CharField(max_length=255)
    text = models.TextField()
    image = models.ImageField(upload_to='posts', null=True, blank=True)

    create_time = models.DateTimeField(auto_now_add=True)
    modify_time = models.DateTimeField(auto_now=True)

    def __str__(self) -> str:
        # magic / dunder methods
        return f'{self.author} - {self.title}'

    def is_recent(self) -> bool:
        return self.create_time.date() == timezone.now().date()

    def get_absolute_url(self) -> str:
        return reverse('blog:post-detail', kwargs={'pk': self.pk})



class Comment(models.Model):
    post = models.ForeignKey(Post, on_delete=models.CASCADE)  # one to many
    # ForeignKey creates modelname_set field to the related model
    author = models.ForeignKey('users.User', on_delete=models.CASCADE)
    text = models.TextField()

    def __str__(self) -> str:
        return f'{self.author} {self.post}'


"""
Tag Model:
title: str

Answer Model:
User: OneToMany
Question: OneToMany

votes: int
text: str
create_time: datetime

Question Model:
User: OneToMany
Tags: ManyToMany

title: str
text: str
votes: int
create_time: datetime
views: int
"""

djangoProject1/templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=viewport, initial-scale=1.0">
    <title>Blog Website</title>

    <link rel="stylesheet" href="{% static 'css/main.css' %}">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" crossorigin="anonymous">

    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.11.8/dist/umd/popper.min.js"
            integrity="sha384-I7E8VVD/ismYTF4hNIPjVp/Zjvgyol6VFvRkX/vR+Vc4jQkC+hVqc2pM8ODewa9r"
            crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/js/bootstrap.min.js"
            integrity="sha384-fbbOQedDUMZZ5KreZpsbe1LCZPVmfTnH7ois6mU1QK+m14rQ1l2bGBq41eYeM/fS"
            crossorigin="anonymous"></script>
</head>
<body style="background-image: url('{% static "imgs/bg-image.jpg" %}'); background-size: cover">
<nav>
    <nav class="navbar navbar-expand-lg bg-dark" data-bs-theme="dark">
        <div class="container-fluid">
            <a class="navbar-brand" href="{% url 'blog:home' %}">Blog App</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse"
                    data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent"
                    aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                </ul>
                <div class="text-white me-2">
                    {% if request.user.is_authenticated %}
                        <a href="{% url 'users:profile' user.profile.pk %}">{{ request.user }}</a>
                        <a class="btn btn-danger" href="{% url 'users:sign-out' %}">Sign Out</a>
                    {% else %}
                        <a class="btn btn-primary" href="{% url 'users:sign-in' %}">Sign In</a>
                        <a class="btn btn-success" href="{% url 'users:sign-up' %}">Sign Up</a>
                    {% endif %}
                </div>
                <form action="{% url 'blog:home' %}" class="d-flex" role="search">
                    <input name="q" value="{{ request.GET.q }}" class="form-control me-2" type="search"
                           placeholder="Search" aria-label="Search">
                    <button class="btn btn-outline-success" type="submit">Search</button>
                </form>
            </div>
        </div>
    </nav>
</nav>
<main class="p-3">
{% block content %}

{% endblock %}
</main>

</body>
</html>

djangoProject1/templates/home.html
{% extends 'base.html' %}

{% block content %}
    <h1>{{ title }}</h1>

    <div>
        <a class="btn btn-primary" href="{% url 'blog:post-create' %}">Add new Post</a>

        {% for post in posts %} {# Template Tag #}
            <!-- Template Tag from HTML Comment -->
            <div style="border: 1px solid black; background-image: url('{% if post.image %}{{ post.image.url }}{% endif %}'); background-position: center;background-size: cover">
                {% if post.is_recent %}
                    <div class="badge">fresh</div>
                {% else %}
                    <div class="badge danger">old</div>
                {% endif %}
                {% for tag in post.tags.all %}
                     <span class="badge bg-info">{{ tag.name }}</span>
                {% endfor %}
                <p>
                    <a href="{{ post.get_absolute_url }}">{{ post.title }}</a>
                    &mdash;
                    <small><a href="{% url 'users:profile' post.author.profile.pk %}">{{ post.author }}</a>{{ post.create_time|timesince }} Ago</small></p>
                <p>{{ post.text|truncatechars:256 }}</p>
            </div>
        {% endfor %}

        {% for page_number in page_obj.paginator.get_elided_page_range %}
            {% if page_number == page_obj.paginator.ELLIPSIS %}
                {{ page_number }}
            {% else %}
                <a
                        href="{% url 'blog:home' %}?page={{ page_number }}&q={{ request.GET.q }}"
                        class="{% if page_number == page_obj.number %}current{% endif %} btn btn-primary    "
                >
                    {{ page_number }}
                </a>
            {% endif %}
        {% endfor %}
    </div>
{% endblock %}

djangoProject1/templates/post_create.html
{% extends 'base.html' %}

{% block content %}
    <div class="bg-dark text-white w-50 mx-auto p-3">
        <form method="POST">
            {% csrf_token %}
            {{ form.as_div  }}
{#            <div class="mb-3">#}
{#                <label for="author" class="form-label">Author</label>#}
{#                <input name="author" class="form-control" id="author" required>#}
{#            </div>#}
{#            <div class="mb-3">#}
{#                <label for="title" class="form-label">Title</label>#}
{#                <input name="title" class="form-control" id="title" required>#}
{#            </div>#}
{#            <div class="mb-3">#}
{#                <label for="text" class="form-label">Text</label>#}
{#                <textarea name="text" class="form-control" id="text" rows="3" required></textarea>#}
{#            </div>#}
            <button class="btn btn-success">POST</button>
        </form>
    </div>

{% endblock %}

djangoProject1/templates/post_delete.html
{% extends 'base.html' %}

{% block content %}
    <div class="bg-dark text-white w-50 mx-auto p-3">
        <form method="POST">
            {% csrf_token %}
            <button class="btn btn-danger">Are you Sure?</button>
            <a href="{{ object.get_absolute_url }}" class="btn btn-success">Cancel</a>
        </form>
    </div>

{% endblock %}

djangoProject1/templates/post_detail.html
{% extends 'base.html' %}

{% block content %}
    <h3>{{ post.title }}</h3>
    {% if request.user == post.author or request.user.is_staff %}
        <a href="{% url 'blog:post-update' post.pk %}" class="btn btn-primary">Update</a>
        <a href="{% url 'blog:post-delete' post.pk %}" class="btn btn-danger">Delete</a>
    {% endif %}
    <p>Modified {{ post.modify_time|timesince }}</p>
    <p>{{ post.author }} posted at {{ post.create_time|date:"Y-b-d" }}</p>
    <p>{{ post.text }}</p>

    <div>
        <h4>Comments</h4>
        <hr/>
        <ul>

            {% for comment in post.comment_set.all %}
                <li>
                    <p>{{ comment.author }} commented</p>
                    <p>{{ comment.text }}</p>
                </li>
            {% endfor %}
        </ul>
        <div class="w-50 mx-auto">
            <form method="post" action="{% url 'blog:comment-create' %}">
                {% csrf_token %}
                <input name="post" value="{{ post.pk }}" hidden/>
                <div class="mb-3">
                    <label for="text" class="form-label">Text</label>
                    <textarea name="text" class="form-control" id="text" rows="4"></textarea>
                </div>
                <button class="btn btn-primary">Comment</button>
            </form>
        </div>

    </div>

{% endblock %}

djangoProject1/templates/post_update.html
{% extends 'base.html' %}

{% block content %}
    <div class="bg-dark text-white w-50 mx-auto p-3">
        <form method="POST">
            {% csrf_token %}
            {{ form.as_div  }}
            <a href="{{ object.get_absolute_url }}" class="btn btn-danger">Cancel</a>
            <button class="btn btn-success">Update</button>
        </form>
    </div>

{% endblock %}